# ANTLR

*grule-rule-engine* is heavily using ANTLR4 lexer/parser to parse GRL rule. The parser
`.go` files were generated by ANTLR4 tools program.

## Download ANTLR4 tools

The latest version can be downloaded [here (antlr-4.8-complete.jar)](https://www.antlr.org/download/antlr-4.8-complete.jar)
Or you can always go to [ANTLR4 download page](https://www.antlr.org/download.html)

Download the `.jar` file and place it somewhere a directory.

Yes, you need Java for this. You can download java from [Oracle's Java Download Page](https://www.oracle.com/java/technologies/javase-downloads.html).
Install java and you're ready to work with ANTLR4.

## Making ANTLR alias.

```bash
alias antlr='java -jar /path/to/downloaded/antlr-4.8-complete.jar'
```

## Executing ANTLR

To build ANTLR4's golang listener or visitor, go to the directory where you
have your antlr4 grammar `.g4` file. And then execute the following command.

```bash
antlr -Dlanguage=Go -o parser -package grulev2 -lib . -listener -visitor grulev2.g4
```

